-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local im  = ui_imgui

local C = {}

C.name = 'Level Validator'
C.description = 'Checks if a level exists.'
C.category = 'repeat_instant'
C.color = im.ImVec4(0.03, 0.3, 0.84, 0.75)
C.pinSchema = {
  {dir = 'in', type = 'flow', name = 'flow'},
  {dir = 'in', type = 'string', name = 'level', description = 'Level dev name to check for.'},

  {dir = 'out', type = 'flow', name = 'True', description = 'Level exists.'},
  {dir = 'out', type = 'flow', name = 'False', description = 'Level does not exist.'}
}

C.tags = {}

function C:init()
  self.levelStr = nil
end

function C:_executionStopped()
  self.levelStr = nil
  self.pinOut.True.value = nil
  self.pinOut.False.value = nil
end

function C:work()
  if self.pinIn.level.value ~= self.levelStr then
    self.levelStr = self.pinIn.level.value
    local valid = false
    local levelList = core_levels.getSimpleList()

    if arrayFindValueIndex(levelList, self.levelStr) or arrayFindValueIndex(levelList, string.lower(self.levelStr)) then
      valid = true
    end

    self.pinOut.True.value = valid
    self.pinOut.False.value = not valid
  end
end

return _flowgraph_createNode(C)
